Unit Interfac;{Armando A. Franyuti Guzman}
{Utileria de interfases, menus, etc}
Interface

Procedure MediaEditor;
Procedure MenuCadNum(Tipo:Char);
Procedure MenuImAn(Tipo:Char);
Procedure MenuTexto;
Procedure MenuLoSo(Tipo:Char);
Procedure Ayuda(Ayu:String;Col:Integer);
Procedure GeneralMenu(Cad:String;pos,xi,yi,xf,yf:Integer);{----------}

Implementation
Uses
  Crt,Dos,Graph,UtMouV04,Iconos,Variable,Lista;

Procedure Ayuda(Ayu:String;Col:Integer);
Begin
  RatonOff;
  Fondo(403,0,GetMaxX  ,19  ,0  ,1,15,8,7);
  Fondo(406,2,GetMaxX-2,19-2,0,1  ,8,15,7);
  SetColor(Col);
  OutTextXY(411,6,Ayu);
  RatonOn;
End;

Procedure MediaEditor;
Begin
  RatonOff;
  Fondo(0,0,GetMaxX,GetMaxY,0,1,7,7,7);
  {--------- Bara del titulo -----------}
  Fondo(0,0,240  ,19  ,0,1,7,0,1);
  Fondo(2,2,240-2,19-2,0,1,0,7,1);
  {Archivo}
  Fondo(241,0,321,19  ,0  ,1,15,8,7);
  Fondo(243,2,321-2,19-2,0,1,8,15,7);
  {Registro}
  Fondo(322,0,402,19  ,0  ,1,15,8,7);
  Fondo(325,2,402-2,19-2,0,1,8,15,7);
  {Ayuda}
  Ayuda('',0);
  {Tirulos}
  SetColor(15);
  OutTextXY(50,6,'EDITOR DE REGISTROS');
  SetColor(1);
  OutTextXY(331,6,'Register');
  {-------------------------------------}
  BotonOff('',7,6,3,3,1);
  RatonOn;
End;

Procedure GeneralMenu(Cad:String;pos,xi,yi,xf,yf:Integer);{----------}
Begin
  p.cs:=ImageSize(xi,yi,xi+xf,yi+yf);
  GetMem(p.cp,p.cs);
  GetImage(xi,yi,xi+xf,yi+yf,p.cp^);
  Fondo  (xi  ,yi   ,xi+xf  ,yi+yf  ,1,1,15,8,7);
  Fondo  (xi+1,yi+1 ,xi+xf-1,yi+20  ,1,1,8,15,7);
  Fondo  (xi+1,yi+20,xi+xf-1,yi+yf-1,1,1,8,15,7);
  Fondo  (xi+2,yi+2 ,xi+xf-3,yi+18 ,0,1,1,1,1);
  IconOff(xi+2,yi+2 ,xi+12,yi+18,1,1,0);
  SetColor(15);
  OutTextXY(xi+Pos,yi+7,Cad);
End;{----------------------------------------------------------------}

Procedure Acomodo(ax,ay:Integer);
Begin
  Fondo(ax+15,ay+81,ax+255,ay+107,0,1,8,15,7);
  SetColor(0);
  OutTextXY(ax+45,ay+85,'xx:');
  OutTextXY(ax+45,ay+95,'');
  OutTextXY(ax+155,ay+90,'x:');
  BotonOff('X',ax+100,ay+91,5,5,1);
  BotonOff(' ',ax+215,ay+91,5,5,1);
End;

Procedure MenuCadNum(Tipo:Char);
Begin
  RatonOff;
  With v do
    Begin
      Case Tipo of
        'C':GeneralMenu('CADENA (Campo)',80,ct.x,ct.y,tcnx,tcny);
        'N':GeneralMenu('NUMERICO (Campo)',70,ct.x,ct.y,tcnx,tcny);
      end;
      Acomodo(ct.x,ct.y);
      Fondo(ct.x+90,ct.y+31,ct.x+220,ct.y+45,0,1,8,15,7);
      Fondo(ct.x+90,ct.y+56,ct.x+123,ct.y+70,0,1,8,15,7);
      SetColor(0);
      OutTextXY(ct.x+227,ct.y+35,'(15)');
      Case Tipo of
        'C':OutTextXY(ct.x+130,ct.y+60,'Caracteres');
        'N':OutTextXY(ct.x+130,ct.y+60,'No. Digitos');
      end;
      BotonOff('Nombre:',ct.x+20,ct.y+35,7,5,1);
      BotonOff('Tamao:',ct.x+20,ct.y+60,7,5,1);
      BotonOff('Aceptar' ,ct.x+50 ,ct.y+123,15,5,1);
      BotonOff('Cancelar',ct.x+160,ct.y+123,14,5,1);
  end;
  RatonOn;
End;

Procedure MenuImAn(Tipo:Char);
Begin
  RatonOff;
  With v do
    Begin
      Case Tipo of
        'I':GeneralMenu('IMAGEN (Campo)',80,ct.x,ct.y,ttxx,ttxy);
        'A':GeneralMenu('ANIMACION (Campo)',65,ct.x,ct.y,ttxx,ttxy);
      end;
      Fondo(ct.x+90,ct.y+31,ct.x+220,ct.y+45,0,1,8,15,7);
      Fondo(ct.x+80,ct.y+56,ct.x+113,ct.y+70,0,1,8,15,7);
      Fondo(ct.x+180,ct.y+56,ct.x+213,ct.y+70,0,1,8,15,7);
      SetColor(0);
      OutTextXY(ct.x+227,ct.y+35,'(15)');
      OutTextXY(ct.x+220,ct.y+60,'Pixel');
      BotonOff('Nombre:',ct.x+20,ct.y+35,7,5,1);
      BotonOff('Ancho:',ct.x+20,ct.y+60,7,5,1);
      BotonOff('Alto:',ct.x+129,ct.y+60,7,5,1);
      BotonOff('Aceptar' ,ct.x+50 ,ct.y+86,15,5,1);
      BotonOff('Cancelar',ct.x+160,ct.y+86,14,5,1);
  end;
  RatonOn;
End;

Procedure MenuTexto;
Begin
  RatonOff;
  With v do
    Begin
      GeneralMenu('TEXTO (Campo)',85,ct.x,ct.y,ttxx,ttxy);
      Fondo(ct.x+90,ct.y+31,ct.x+220,ct.y+45,0,1,8,15,7);
      Fondo(ct.x+96,ct.y+56,ct.x+129,ct.y+70,0,1,8,15,7);
      Fondo(ct.x+221,ct.y+56,ct.x+254,ct.y+70,0,1,8,15,7);
      SetColor(0);
      OutTextXY(ct.x+227,ct.y+35,'(15)');
      BotonOff('Nombre:',ct.x+20,ct.y+35,7,5,1);
      BotonOff('No. Ren:',ct.x+20,ct.y+60,7,5,1);
      BotonOff('Col/Chr:',ct.x+145,ct.y+60,7,5,1);
      BotonOff('Aceptar' ,ct.x+50 ,ct.y+86,15,5,1);
      BotonOff('Cancelar',ct.x+160,ct.y+86,14,5,1);
  end;
  RatonOn;
End;

Procedure MenuLoSo(Tipo:Char);
Begin
  RatonOff;
  With v do
    Begin
      Case Tipo of
        'L':GeneralMenu('LOGICO (Campo)',80,ct.x,ct.y,tlsx,tlsy);
        'S':GeneralMenu('SONIDO (Campo)',80,ct.x,ct.y,tlsx,tlsy);
      end;
      Fondo(ct.x+90,ct.y+31,ct.x+220,ct.y+45,0,1,8,15,7);
      SetColor(0);
      OutTextXY(ct.x+227,ct.y+35,'(15)');
      BotonOff('Nombre:',ct.x+20,ct.y+35,7,5,1);
      BotonOff('Aceptar' ,ct.x+50 ,ct.y+62,15,5,1);
      BotonOff('Cancelar',ct.x+160,ct.y+62,14,5,1);
  end;
  RatonOn;
End;

End.
     {------------- Barra de comandos ---------------------}
     {pMouBar(451,GetMaxY-20,GetMaxX,GetMaxY,0,1,15,8,7);
     pMouBar(453,GetMaxY-18,GetMaxX-2,GetMaxY-2,0,1,8,15,7);

