Unit PatoUnit;
{Armando Franyuti}
{Vladimir Ilch Ulianov}
{Dr. Nureyev}
{Abraham Snchez}
{El Jefe}
{Luis Donald Duck}
{Carlos Gershenson}
{Ral Salinas de Gortari alias la Rata}
Interface

Uses
	cab,lista,crt,captura,treeunit;

Var
        F:file;
	n:string;


function  getregpato(arch:string):integer;
Procedure insertarpato(arch,cad,reg:string);
function  leePato(var f:file):boolean;
Procedure verpato(arch:string);
Procedure Borrarpato(arch,cad,n{registro a borrar}:string;bor:boolean);
Procedure Eliminarpato(arch,cad:string);
procedure CopyFile(var FromF, ToF: file);
function  FileExists(FileName: String): Boolean;

Implementation

Procedure Check(var CH:real);
var
  res:integer;

begin
  Repeat
  {$I-}
    readln(CH);
    res:=IOresult;
  {$I+}
  if res<>0 then
  begin
    writeln('Error,trate de nuevo');
  end;
  Until res=0;
end;

function FileExists(FileName: String): Boolean;
var
 Files: file;
begin
 {$I-}
 Assign(Files, FileName);
 {FileMode := 0;   Set file access to read only }
 Reset(Files);
 Close(Files);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;

procedure CopyFile(var FromF, ToF: file);

var
  NumRead, NumWritten: Word;
  Buf: array[1..2048] of Char;
begin
  Reset(FromF, 1);  { Record size = 1 }
  Rewrite(ToF, 1);  { Record size = 1 }
  repeat
    BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
    BlockWrite(ToF, Buf, NumRead, NumWritten);
  until (NumRead = 0) or (NumWritten <> NumRead);
  Close(FromF);
  Close(ToF);
end;

function getregpato(arch:string):integer;
var i:integer;
    size:longint;
    v:char;

begin
     Assign(F,arch+'.pat');
     If Fileexists(arch+'.pat') then
     begin
       Reset(f,1);
       size:=filesize(f);
       i:=1;
       repeat
         Blockread(f,v,1);
         If v in ['',''] then
           i:=i+1;
       until filepos(f)>=size;
       getregpato:=i;
     end
     else
       getregpato:=1;
end;

Procedure insertarpato(arch{nombre de base de datos sin .pat}
                      ,cad{nombre del header sin .cab}
                      ,reg{nombre del registro}:string);
var
   h,v,g2,m:char;
   r,l2:listaptr;
   t:P_Dato;
   i:integer;
   key:patoreg;
   pos:longint;

Begin
     Assign(F,arch+'.pat');
     i:=0;
     New(r);
     r^.nombre:=cad;
     leecab(r);
     l2:=r^.ptr;
     t:=t1;
     while (t^.s_num<>1) do t:=t^.sig;
   {  t:=t^.sig;{pendejada del jefe}
     If not fileexists(arch+'.pat') then
     begin
       rewrite(f,1);
     end
     else
     begin
       Reset(F,1);
       seek(F,filesize(f));
     end;
     pos:=filepos(f);
     key.key:=reg;
     key.pos:=pos;
     key.bor:=false;
     insertartree(arch+'.'+ITS(i),key);
     v:='';
     Blockwrite(f,v,1);    {escribe marca de inico de registro}
     Blockwrite(f,reg[1],length(reg));    {escribe cadena de registro}
     v:='';
     Blockwrite(f,v,1);    {escribe marca de cadena }
     repeat
       i:=i+1;
       n:=t^.s_dat;
       key.key:=n;
       key.pos:=pos;
       key.bor:=false;
       insertartree(arch+'.'+ITS(i),key);
       t:=t^.sig;
       Case l2^.Tipo of
         'C':begin
           v:='';
           Blockwrite(f,n[1],length(n));
           Blockwrite(f,v,1);    {escribe cadena}
         end;
         'N':begin
           v:='';
           Blockwrite(f,n[1],length(n));
           Blockwrite(f,v,1);    {escribe cadena}
         end;
         'L':begin
           v:='';
           Blockwrite(f,n[1],length(n));
           Blockwrite(f,v,1);    {escribe cadena}
         end;
         'I':begin
           v:='';
           Blockwrite(f,n[1],length(n));
           Blockwrite(f,v,1);    {escribe cadena}
         end;
         'S':begin
           v:='';
           Blockwrite(f,n[1],length(n));
           Blockwrite(f,v,1);    {escribe cadena}
         end;
         'T':begin
           v:='';
           Blockwrite(f,n[1],length(n));
           Blockwrite(f,v,1);    {escribe cadena}
         end;
         'A':begin
           v:='';
           Blockwrite(f,n[1],length(n));
           Blockwrite(f,v,1);    {escribe cadena}
         end;
       end;
       l2:=l2^.ptr;

     until l2=nil;
     Close(F);
End;

function leePato(var f:file):boolean;{si leepato regresa falso, es que }
                                      {el registro est borrado logicamente}
var
    i,j:byte;
    car:char;
    regex:boolean;
    size,pos:longint;
    t:P_Dato;


begin
     j:=0;
     t:=t1;
     n:='';
     size:=filesize(f);
     Blockread(f,car,1);     {lee caracter de registro}
     If car = '' then
     begin
       leepato:=false;
       repeat
         Blockread(f,car,1);     {lee caracter de registro}
       until car='';
       end;
     If car = '' then
       leepato:=true;
     repeat
       i:=0;
       repeat
         inc(i);
         Blockread(f,car,1);     {lee la cadena}
         if (car in [#0..#198]) or (car in [#209..#255]) then
            n[i]:=car;
         pos:=filepos(f);
       until (car in [''..''])or(pos>=size);
       n[0]:=chr(i-1);
       j:=j+1;
       t^.s_num:=j;
       t^.s_dat:=n;
       t:=t^.sig;
     until (car in ['',''])or(pos>=size);
     If pos<size then
       seek(f, filepos(f)-1);
end;

Procedure verpato(arch:string);

var
   pos,size:integer;
   w:byte;
   regex:boolean;
   t:P_Dato;

Begin
    { Assign(F,arch+'.pat');
     if FileExists(arch+'.pat') then
     begin
       Reset(F,1);
       size:=filesize(f);
       repeat
        leepato(arch +'.pat');
        pos:=filepos(f);
       until pos>=size;

       {para regresar un registro}

       { repeat
         seek(f,filepos(f)-2;
         blockread(f,w,1);
       until w in ['',''];
       seek(f,filepos(f)-1;


       }
   {    Close(F);
     end
     else begin
       Writeln('No se encontro el archivo. Presione Enter...');readln;end;
    }
End;

Function find(cad,nom:string;var pos: longint;var arch:file):boolean;
var
    n:string;
    i:byte;
    car:char;
    size:integer;
    fin:boolean;

begin
     Find:=false;
     Fin:=false;
     if FileExists(nom) then
     begin
     Reset(arch,1);
     size:=filesize(arch);
      repeat
        i:=0;
        repeat
          inc(i);
          Blockread(f,car,1);
          if (car in [#0..#198]) or (car in [#209..#255]) then
             n[i]:=car;
        until car in [''..''];
        n[0]:=chr(i-1);
        If cad=n then
        begin
          Find:=true;
          Fin:=true;
          pos:=filepos(arch)-(i+1);
        end
        else
          pos:=filepos(arch);
      until (pos>=size) or (Fin=true);
     If (pos>=size) and (Fin=false) then
     begin
       writeln('No se encont en el archivo');
       readln;
     end;

     Close(F);
     end
     else
     begin
       Writeln('No se encontro el archivo. Presione Enter...');readln;

       find:=false;

     end;
end;

Procedure Borrarpato(arch,cad,n{registro a borrar}:string;
                    bor:boolean{si es verdadero, borra, si no, desborra});
var
    v,car:char;
    posborr:longint;
    key:patoreg;
    i:integer;
    r,l2:listaptr;

begin
     Assign(F,arch+'.pat');
     i:=0;
     New(r);
     r^.nombre:=cad;
     leecab(r);
     l2:=r;
     If find(n{registro a borrar},arch+'.pat',posborr,F) then
     begin
       Reset(f,1);
       v:='';
       seek(f,posborr);
       Blockwrite(f,v,1);
       Close(f);
       key.pos:=posborr;
       If bor then
         key.bor:=true
       else
         key.bor:=false;
       key.key:='';
       repeat
         marcatree(arch+'.'+ITS(i),key);
         i:=i+1;
         l2:=l2^.ptr;
       until l2=nil;
       Write (n,' borrado, presione enter...');
     end;
end;

Procedure Eliminarpato(arch,cad:string);
var
    v:char;
    i,j:integer;
    pos,size:longint;
    f2:file;
    l2,r:listaptr;
    key:patoreg;

begin
     New(r);
     r^.nombre:=cad;
     leecab(r);
     l2:=r;
     i:=0;
     repeat
       i:=i+1;
       l2:=l2^.ptr;
     until l2=nil;
     j:=i;
     i:=0;
     Assign(F,arch+'.pat');
     If fileexists(arch+'.pat') then
     begin
       v:=#0;
       Assign (f2,'@.@');
       Reset(f,1);
       Rewrite(f2,1);
       size:=filesize(f);
       Repeat
         If (v<>'')and(v<>'') then
           Blockread(f,v,1);
         If v='' then
         repeat
           Blockwrite(f2,v,1);
           Blockread(f,v,1);
           pos:=filepos(f);
           For i:=0 to j do
           begin
             BuscarTreePos(arch+'.'+ITS(i),pos,key);
             insertartree('@.'+ITS(i),key);
           end;
         until (pos>=size)or (v='')
         else
         repeat
           Blockread(f,v,1);
           pos:=filepos(f);
         until (pos>=size)or (v='');
         pos:=filepos(f);
       until pos>=size;
       Blockwrite(f2,v,1);
       Close(f);
       Close(f2);
       Copyfile(f2,f);
       Erase(f2);
       For i:=0 to j do
       begin
         Assign(f2,'@.'+ITS(i));
         Assign(f,arch+'.'+ITS(i));
         Copyfile(f2,f);
         Erase(f2);
       end;

       Write ('Registros eliminados, presione enter...');
     end;
end;
End.