Unit SubMenus;

Interface
Function MenuEditor(Var meFlag:Boolean):Integer;
Function MenuCaptura(Var Fl1,Fl2:Boolean):Integer;
Function MenuVisual(Var mvFlag:Boolean):Integer;
Function NuevoAbrirEditor(tipo:Byte):String;
Function DeseasBorrar:Boolean;

Implementation
Uses
  Dos,Graph,Crt,UtMouV04,Interfac,Lista,Frases,Arrastre,Variable;

Function MenuEditor(Var meFlag:Boolean):Integer;
Const
  x=35;
  y=26;
Var
  sp    :Pointer;
  sw    :Word;
  Flag  :Boolean;
Begin
  MenuEditor:=0;
  Flag:=False;
  RatonOff;
  sw:=ImageSize(x-5,y-5,x+150,y+100);
  GetMem(sp,sw);
  GetImage(x-5,y-5,x+150,y+100,sp^);
  BotonOff('   Nuevo    ',x+4 ,y    ,9,5,1);
  BotonOff('   Abrir    ',x+4 ,y+16 ,9,5,1);
  BotonOff('  Guardar   ',x+4 ,y+32 ,9,5,1);
  BotonOff('Guardar como',x+4 ,y+48 ,9,5,1);
  BotonOff('   Salir    ',x+4 ,y+64 ,9,5,1);
  RatonOn;
  Repeat
    reg.ax:=$03;
    intr($33,reg);
    if (reg.bx = $01) then
      Begin
        Flag:=True;
        if BotonExe('   Nuevo    ',x+4 ,y    ,9,5,1,0)=1 then
           Begin
             meFlag:=True;
             MenuEditor:=1;
           end;
        if BotonExe('   Abrir    ',x+4 ,y+16 ,9,5,1,0)=1 then
           Begin
             meFlag:=True;
             MenuEditor:=2;
           end;
        if (BotonExe('  Guardar   ',x+4 ,y+32 ,9,5,1,0)=1) and
           (meFlag=True) then
           MenuEditor:=3;
        if (BotonExe('Guardar como',x+4 ,y+48 ,9,5,1,0)=1) and
           (meFlag=True) then
           MenuEditor:=4;
        if BotonExe('   Salir    ',x+4 ,y+64 ,9,5,1,0)=1 then
           MenuEditor:=5;
      end;
  Until Flag=True;
  RatonOff;
  PutImage(x-5,y-5,sp^,NormalPut);
  FreeMem(sp,sw);
  Delay(200);
  RatonOn;
End;

Function MenuCaptura(Var Fl1,Fl2:Boolean):Integer;
Const
  x=35;
  y=26;
Var
  sp    :Pointer;
  sw    :Word;
  Flag  :Boolean;
Begin
  MenuCaptura:=0;
  Flag:=False;
  RatonOff;
  sw:=ImageSize(x-5,y-5,x+200,y+100);
  GetMem(sp,sw);
  GetImage(x-5,y-5,x+200,y+100,sp^);
  BotonOff('  Abrir plantilla  ',x+4 ,y    ,9,5,1);
  BotonOff('Abrir base de datos',x+4 ,y+16 ,9,5,1);
  BotonOff('Nueva base de datos',x+4 ,y+32 ,9,5,1);
  BotonOff('      Guardar      ',x+4 ,y+48 ,9,5,1);
  BotonOff('   Guardar como    ',x+4 ,y+64 ,9,5,1);
  BotonOff('       Salir       ',x+4 ,y+80 ,9,5,1);
  RatonOn;
  Repeat
    reg.ax:=$03;
    intr($33,reg);
    if (reg.bx = $01) then
      Begin
        Flag:=True;
        if BotonExe('  Abrir plantilla  ',x+4 ,y    ,9,5,1,0)=1 then
           Begin
             Fl1:=True;
             MenuCaptura:=1;
           end;
        if (BotonExe('Abrir base de datos',x+4  ,y+16 ,9,5,1,0)=1) and
           (Fl1=True) then
           MenuCaptura:=2;
        if (BotonExe('Nueva base de datos',x+4  ,y+32 ,9,5,1,0)=1) and
           (Fl1=True) then
           MenuCaptura:=3;
        if (BotonExe('      Guardar      ',x+4  ,y+48 ,9,5,1,0)=1) and
           (Fl1=True) and (Fl2=True) then
           MenuCaptura:=4;
        if (BotonExe('   Guardar como    ',x+4  ,y+64 ,9,5,1,0)=1) and
           (Fl1=True) and (Fl2=True) then
           MenuCaptura:=5;
        if BotonExe('       Salir       ',x+4  ,y+80 ,9,5,1,0)=1 then
           MenuCaptura:=6;
      end;
  Until Flag=True;
  RatonOff;
  PutImage(x-5,y-5,sp^,NormalPut);
  FreeMem(sp,sw);
  Delay(200);
  RatonOn;
End;

Function NuevoAbrirEditor(tipo:Byte):String;
Var
  CadTemp:String;

Begin
  RatonOff;
  Case tipo of
    1:GeneralMenu('Nueva plantilla',27,v.ct.x,v.ct.y,253,55);
    2:GeneralMenu('Abrir plantilla',27,v.ct.x,v.ct.y,253,55);
    3:GeneralMenu('Nueva base de datos',27,v.ct.x,v.ct.y,253,55);
    4:GeneralMenu('Abrir base de datos',27,v.ct.x,v.ct.y,253,55);
    5:GeneralMenu('Cuardar como',27,v.ct.x,v.ct.y,253,55);
    6:GeneralMenu(Dato.Nombre,27,v.ct.x,v.ct.y,282,55);
  end;
  SetColor(0);
  OutTextXY(v.ct.x+12,v.ct.y+33,'Nombre del Archivo:');
  if tipo <> 6 then
    Begin
      Fondo(v.ct.x+170,v.ct.y+30,v.ct.x+240,v.ct.y+43,0,1,8,15,7);
      CadTemp:=NomCad(v.ct.x+173,v.ct.y+33,8,0);
      if CadTemp='' then CadTemp:='BackUp';
    end
  else
    Begin
      Fondo(v.ct.x+170,v.ct.y+30,v.ct.x+272,v.ct.y+43,0,1,8,15,7);
      CadTemp:=NomCad(v.ct.x+173,v.ct.y+33,12,0);
    end;
  {Archivo}
  if tipo <> 6 then
    Begin
      Fondo(241,0,321,19  ,0  ,1,15,8,7);
      Fondo(243,2,321-2,19-2,0,1,8,15,7);
      SetColor(0);
      OutTextXY(250,6,CadTemp);
    end;
  {-------}
  NuevoAbrirEditor:=CadTemp;
  MenuCamposFreeMem;
  RatonOn;
End;


Function DeseasBorrar:Boolean;
Var Paso:Boolean;
Begin
  RatonOff;
  GeneralMenu('El archivo ya existe  Deseas borrarlo ?',20,
  v.ct.x,v.ct.y,350,55);
  BotonOff('Si',v.ct.x+90 ,v.ct.y+33,65,6,1);
  BotonOff('No',v.ct.x+250,v.ct.y+33,65,6,1);
  RatonOn;
  Paso:=False;
  Repeat
    reg.ax:=$03;
    intr($33,reg);
    if (reg.bx = $01) then
      Begin
        if BotonExe('Si',v.ct.x+90 ,v.ct.y+33,65,6,1,0)=1 then
           Begin
             Paso:=True;
             DeseasBorrar:=True;
           end;
        if BotonExe('No',v.ct.x+250,v.ct.y+33,65,6,1,0)=1 then
           Begin
             Paso:=True;
             DeseasBorrar:=False;
           end;
      end;
  Until Paso=True;
  MenuCamposFreeMem;
End;

Function MenuVisual(Var mvFlag:Boolean):Integer;
Const
  x=35;
  y=26;
Var
  sp    :Pointer;
  sw    :Word;
  Flag  :Boolean;
Begin
  MenuVisual:=0;
  Flag:=False;
  RatonOff;
  sw:=ImageSize(x-5,y-5,x+250,y+130);
  GetMem(sp,sw);
  GetImage(x-5,y-5,x+250,y+130,sp^);
  BotonOff('Abrir base de datos',x+4 ,y    ,9,5,1);
  BotonOff('  Borrar registro  ',x+4 ,y+16 ,9,5,1);
  BotonOff('Recuperar registro ',x+4 ,y+32 ,9,5,1);
  BotonOff('Eliminacin fisica ',x+4 ,y+48 ,9,5,1);
  BotonOff('      Indices      ',x+4 ,y+64 ,9,5,1);
  BotonOff('      Bsqueda     ',x+4 ,y+80 ,9,5,1);
  BotonOff('       Salir       ',x+4 ,y+96 ,9,5,1);
  RatonOn;
  Repeat
    reg.ax:=$03;
    intr($33,reg);
    if (reg.bx = $01) then
      Begin
        Flag:=True;
        if BotonExe('Abrir base de datos',x+4 ,y    ,9,5,1,0)=1 then
           Begin
             mvFlag:=True;
             MenuVisual:=1;
           end;
        if (BotonExe('  Borrar registro  ',x+4 ,y+16 ,9,5,1,0)=1) and
           (mvFlag=True) then
           Begin
             MenuVisual:=2;
           end;
        if (BotonExe('Recuperar registro ',x+4 ,y+32 ,9,5,1,0)=1) and
           (mvFlag=True) then
           Begin
             MenuVisual:=3;
           end;
        if (BotonExe('Eliminacin fisica ',x+4 ,y+48 ,9,5,1,0)=1) and
           (mvFlag=True) then
           Begin
             MenuVisual:=4;
           end;
        if (BotonExe('      Indices      ',x+4 ,y+64 ,9,5,1,0)=1) and
           (mvFlag=True) then
           Begin
             MenuVisual:=5;
           end;
        if (BotonExe('      Bsqueda     ',x+4 ,y+80 ,9,5,1,0)=1) and
           (mvFlag=True) then
           Begin
             MenuVisual:=6;
           end;
        if BotonExe('       Salir       ',x+4 ,y+96 ,9,5,1,0)=1 then
             MenuVisual:=7;
      end;
  Until Flag=True;
  RatonOff;
  PutImage(x-5,y-5,sp^,NormalPut);
  FreeMem(sp,sw);
  Delay(200);
  RatonOn;
End;


End.