Unit Arrastre;
{Procedimiento que ejecuta el arrastre sobre el editor}
Interface

Procedure ArrastraObj(Var AoX,AoY:Integer;Var AoPtr:Pointer;
                      Var AoSiz:Word;TamX,TamY:Integer);
Procedure MenuCamposFreeMem;
Procedure CampoMovil(Var cmP:Pointer);
Procedure PintaCampo;

Implementation
Uses
  Crt,Dos,Graph,UtMouV04,Variable,Lista,Interfac,Iconos;
Var
  TmpX,TmpY:Integer;

Procedure Rectangulo(xi,yi,xd,yd:Integer);{-------------------------}
Begin
   Rectangle(Xi, Yi, Xi + xD, Yi + yD); {Dibuja}
   Delay(20);
   Rectangle(Xi, Yi, Xi + xD, Yi + yD); {Borra}
   TmpX:=xi;{Nota: La variable TemAoX y TemAoY se utiliza para}
   TmpY:=yi;{colocar el campo  en el editor                   }
End;{----------------------------------------------------------------}

Procedure ArrastraObj(Var AoX,AoY:Integer;Var AoPtr:Pointer;
                      Var AoSiz:Word;TamX,TamY:Integer);
Var
  Flag         :Boolean;
  {Imajen Superior Temporal}
  TemPtr       :Pointer;
  TemSize      :Word;
Begin
  RatonOff;
  Flag:=False;
  {Nueva imagen superior}
  TemSize:=ImageSize(AoX,AoY,AoX+TamX,AoY+TamY);
  GetMem(TemPtr,TemSize);
  GetImage(AoX,AoY,AoX+TamX,AoY+TamY,TemPtr^);
  {Se pega la vieja imagen}
  PutImage(AoX,Aoy,AoPtr^,NormalPut);
  FreeMem(AoPtr,AoSiz);
  {XOR mode for rectangle}
  SetWriteMode(XORPut);
  Repeat
    Reg.ax:=$03;
    Intr($33,Reg);
    Rectangulo(Reg.cx,Reg.dx,TamX,TamY);
    if Reg.bx<>$01 then
      Begin
        if TmpX+TamX>=GetMaxX then
           TmpX:=TmpX-((TmpX+TamX)-GetMaxX);
        if TmpY+TamY>=GetMaxY then
           TmpY:=TmpY-((TmpY+TamY)-GetMaxY);
        SetWriteMode(NormalPut);
        {Nueva imagen inferior}
        AoSiz:=ImageSize(TmpX,TmpY,TmpX+TamX,TmpY+TamY);
        GetMem(AoPtr,AoSiz);
        GetImage(TmpX,TmpY,TmpX+TamX,TmpY+TamY,AoPtr^);
        {Se pega la imagen superior}
        PutImage(TmpX,TmpY,TemPtr^,NormalPut);
        FreeMem(TemPtr,TemSize);
        {Igualar las variables}
        AoX:=TmpX;
        AoY:=TmpY;
        Flag:=True;
      end;
  Until Flag=True;
  RatonRes;
  RatonON;
End;

Procedure MenuCamposFreeMem;
{Libera la memoria al arrastrar el menu de algun campo}
Begin
  RatonOff;
  PutImage(v.ct.x,v.ct.y,p.cp^,NormalPut);
  FreeMem(p.cp,p.cs);
  RatonOn;
End;

Procedure PintaCampo;
Begin
  RatonOff;
  With Dato do
    Begin
      SetColor(0);
      OutTextXY(xi,yi+4,Nombre);
      if Forma = false then
        Case Tipo of
    'C','N','L':Fondo(xi+(Length(Nombre)*8)+4,yi,xf+2,yf,0,1,8,15,7);
            'S':BotonOff('',xi+(Length(Nombre)*8)+4+4,yi+4,4,4,1);
        end
      else
        Begin
          if Tipo='A' then
            BotonOff('',xi+(Length(Nombre)*8)+4+4,yi+4,4,4,1);
          Fondo(xi,yi+14,xf+2,yf,0,1,8,15,7);
        end;
    end;
  RatonOn;
End;

Procedure CampoMovil(Var cmP:Pointer);
Var  Flag   :Boolean;
Begin
  Delay(250);
  Flag:=False;
  RatonOff;
  Ayuda('Izq: Insertar  Der: Canselar',0);
  SetColor(8);
  {Pega la imagen inferior de los Iconos}
  PutImage(v.ba.x,v.ba.y,cmP^,NormalPut);
  {XOR mode for rectangle}
  SetWriteMode(XORPut);
  Repeat
    Reg.ax:=$03;
    Intr($33,Reg);
    Rectangulo(Reg.cx,Reg.dx,Dato.tx,Dato.ty);
    if Reg.bx=$01 then
      Begin
        {Derecha}
        if TmpX+Dato.tX>=GetMaxX then
           TmpX:=TmpX-((TmpX+Dato.tX)-GetMaxX);
        {Inferior}
        if TmpY+Dato.tY>=GetMaxY then
           TmpY:=TmpY-((TmpY+Dato.tY)-GetMaxY);
        {Superior}
        if TmpY<=20 then
           TmpY:=TmpY+(20-TmpY);
        if CheckPointList(TmpX,TmpY,TmpX+Dato.tx,TmpY+Dato.ty,L1)=1 then
          Begin
            Flag:=True;
            SetWriteMode(NormalPut);
            Dato.xi:=TmpX;
            Dato.yi:=TmpY;
            Dato.xf:=TmpX+Dato.tx;
            Dato.yf:=TmpY+Dato.ty;
            Inc(ListCont);
            PintaCampo;
            InsertList(L2,Dato);
            IconosPaint;
          end;
      end;
    if Reg.bx=$02 then
      Begin
        SetWriteMode(NormalPut);
        Flag:=True;
        IconosPaint;
      end;
  Until Flag=True;
  Ayuda('',0);
  RatonON;
End;
End.

