Unit Iconos;{Armando A. Franyuti Guzmn}

Interface

{--------------------- Botones tipo ICONO --------------------------}
Procedure IconOff(Xi,Yi,Xf,Yf,Ps,Pc,Pimg:Integer);
Function  IconExe(Xi,Yi,Xf,Yf,fS,fc,fT,fimg:Integer):Byte;
{-- Datos generales de la BARRA DE ICONOS --}
Procedure ReWriteIconosVar;
Procedure IconosPaint;
{----------------------------------------------------}

Implementation

Uses Dos,Crt,Graph,UtMouV04,Variable;

Procedure pIcoCaden(No:Byte);{------------- pIcoCaden ---------------}
Var itx,ity:Integer;
Begin
  if No=1 then
    Begin
      itx:=v.ic.x+2;
      ity:=v.ic.y+2;
    end
  else
    Begin
      itx:=v.ic.x;
      ity:=v.ic.y;
    end;
  SetColor(0);
  OutTextXY(itx+4,ity+4,'C');
  OutTextXY(itx+10,ity+9,'a');
  OutTextXY(itx+15,ity+15,'d');
End;{----------------------------------------------------------------}

Procedure pIcoNumer(No:Byte);{------------- pIcoNumer ---------------}
Var itx,ity:Integer;
Begin
  if No=1 then
    Begin
      itx:=v.ie.x+2;
      ity:=v.ie.y+2;
    end
  else
    Begin
      itx:=v.ie.x;
      ity:=v.ie.y;
    end;
  SetColor(0);
  OutTextXY(itx+3,ity+4,'1');
  OutTextXY(itx+9,ity+9,'2');
  OutTextXY(itx+15,ity+15,'3');
End;{----------------------------------------------------------------}

Procedure pIcoLogic(No:Byte);{------------- pIcoLogic ---------------}
Var itx,ity:Integer;
Begin
  if No=1 then
    Begin
      itx:=v.il.x+2;
      ity:=v.il.y+2;
    end
  else
    Begin
      itx:=v.il.x;
      ity:=v.il.y;
    end;
  SetColor(0);
  OutTextXY(itx+6,ity+6,#62);
  OutTextXY(itx+14,ity+14,#60);
End;{----------------------------------------------------------------}

Procedure pIcoImage(No:Byte);{------------- pIcoImage ---------------}
Var itx,ity:Integer;
Begin
  if No=1 then
    Begin
      itx:=v.ii.x+2;
      ity:=v.ii.y+2;
    end
  else
    Begin
      itx:=v.ii.x;
      ity:=v.ii.y;
    end;
  SetFillStyle(1,0);
  Bar(itx+6,ity+10,itx+19,ity+19);
  SetColor(7);
  OutTextXY(itx+9,ity+11,#9);
  SetColor(0);
  OutTextXY(itx+8,ity+4,#28);
  OutTextXY(itx+11,ity+7,#248);
End;{----------------------------------------------------------------}

Procedure pIcoSound(No:Byte);{------------ pIcoSound ----------------}
Var itx,ity:Integer;
Begin
  if No=1 then
    Begin
      itx:=v.is.x+2;
      ity:=v.is.y+2;
    end
  else
    Begin
      itx:=v.is.x;
      ity:=v.is.y;
    end;
  SetFillStyle(1,0);
  Bar(itx+4,ity+10,itx+6,ity+16);
  SetColor(0);
  Ellipse(itx+13,ity+13,86 ,270,7,7);
  Ellipse(itx+13,ity+13,86 ,270,3,7);
  Ellipse(itx+12,ity+13,286,90 ,3,7);
  Ellipse(itx+16,ity+13,290,80 ,3,4);
  Ellipse(itx+18,ity+13,290,80 ,3,6);
  Ellipse(itx+11,ity+13,286, 90,3,3);
  SetFillStyle(1,0);
  FloodFill(itx+9,ity+13,0);
  {SetColor(7);
  Line(itx+6,ity+10,itx+6,ity+16);}
End;{----------------------------------------------------------------}

Procedure pIcoTexto(No:Byte);{------------- pIcoTexto ---------------}
Var itx,ity:Integer;
Begin
  if No=1 then
    Begin
      itx:=v.it.x+2;
      ity:=v.it.y+2;
    end
  else
    Begin
      itx:=v.it.x;
      ity:=v.it.y;
    end;
  SetColor(0);
  OutTextXY(itx+5,ity+9,'Tx');
End;{----------------------------------------------------------------}

Procedure pIcoAnima(No:Byte);{------------- pIcoAnima ---------------}
Var itx,ity:Integer;
Begin
  if No=1 then
    Begin
      itx:=v.ia.x+2;
      ity:=v.ia.y+2;
    end
  else
    Begin
      itx:=v.ia.x;
      ity:=v.ia.y;
    end;
  SetColor(0);
  OutTextXY(itx+4,ity+6,#248);
  OutTextXY(itx+9,ity+6,#248);
  SetFillStyle(1,0);
  Bar(itx+5,ity+11,itx+14,ity+16);
  OutTextXY(itx+14,ity+10,#17);
  Line(itx+10,ity+16,itx+5,ity+20);
  Line(itx+10,ity+16,itx+14,ity+20);
End;{----------------------------------------------------------------}

{----------------- Ejecuta las imagenes de los iconos ---------------}
Procedure pExecIconImage(pNo,IO:Integer);
Begin
  Case pNo of
    1:pIcoCaden(IO);
    2:pIcoNumer(IO);
    3:pIcoLogic(IO);
    4:pIcoImage(IO);
    5:pIcoSound(IO);
    6:pIcoTexto(IO);
    7:pIcoAnima(IO);
  end
End;{----------------------------------------------------------------}

{--------------------------- Icono inactivo -------------------------}
Procedure IconOff(Xi,Yi,Xf,Yf,pS,Pc,pimg:Integer);
Var pCont:Byte;
Begin
  SetFillStyle(1,Pc);
  Bar(Xi,Yi,Xf,Yf);
  SetColor(0);
  Rectangle(Xi,Yi,Xf,Yf);
  SetColor(15);
  For pCont:=1 to pS do
    Begin
      Line(Xi+pCont,Yi+pCont,Xf-pCont,Yi+pCont);
      Line(Xi+pCont,Yi+pCont,Xi+pCont,Yf-pCont);
    End;
  SetColor(8);
  For pCont:=1 to pS do
    Begin
      Line(Xi+pCont,Yf-pCont,Xf-pCont,Yf-pCont);
      Line(Xf-pCont,Yi+pCont,Xf-pCont,Yf-pCont);
    End;
  pExecIconImage(pimg,0);
End;{----------------------------------------------------------------}

{--------------------------- Icono activo ---------------------------}
Procedure pIcoOn(Xi,Yi,Xf,Yf,pS,Pc,pimg:Integer);
Var fcont:Byte;
Begin
  SetFillStyle(1, Pc);
  Bar(Xi,Yi,Xf,Yf);
  SetColor(0);
  SetColor(8);
  For fcont:=1 to pS+1 do
    Begin
      Line(Xi+fcont,Yi+fcont,Xf-fcont,Yi+fcont);
      Line(Xi+fcont,Yi+fcont,Xi+fcont,Yf-fcont);
    End;
  pExecIconImage(pimg,1);
End;{----------------------------------------------------------------}

{-------------------- Ejecuta el Icono con el Mouse -----------------}
Function IconExe(Xi,Yi,Xf,Yf,fS,fc,fT,fimg:Integer):Byte;
var flag:boolean;
Begin
  IconExe:=0;
  if (reg.cx >= Xi) and (reg.cx <= Xf) then
    Begin
      if (reg.dx >= Yi) and (reg.dx <= Yf) then
        Begin
          RatonOff;{P}
          pIcoOn(Xi,Yi,Xf,Yf,fS,fc,fimg);{P}
          Flag:=False;
          if ft = 0 then
            Repeat
              reg.ax:=$03;
              Intr($33,reg);
              if reg.bx<>$01 then
                 Flag:=True;
              Until Flag=True
          else
            Delay(50);
          IconOff(Xi,Yi,Xf,Yf,fS,fc,fimg);{P}
          RatonOn;{P}
          IconExe:=1;
          Reg.cx:=$00;
          Reg.dx:=$00;
        end;
    end;
End;{----------------------------------------------------------------}

Procedure RewriteIconosVar;
Begin
  With v do
    Begin
      ic.x:=ba.x;{}ic.y:=ba.y+10;
      ie.x:=ba.x;{}ie.y:=ba.y+35;
      il.x:=ba.x;{}il.y:=ba.y+60;
      ii.x:=ba.x;{}ii.y:=ba.y+85;
      is.x:=ba.x;{}is.y:=ba.y+110;
      it.x:=ba.x;{}it.y:=ba.y+135;
      ia.x:=ba.x;{}ia.y:=ba.y+160;
    end;
End;

Procedure IconosPaint;
Begin
  With v do
    Begin
      p.is:=ImageSize(ba.x,ba.y,ba.x+25,ba.y+185);
      GetMem(p.ip,p.is);
      GetImage(ba.x,ba.y,ba.x+25,ba.y+185,p.ip^);
      IconOff(ba.x,ba.y,ba.x+25,ba.y+10,1,1,0);
      IconOff(ic.x,ic.y,ic.x+25,ic.y+25,2,7,1);
      IconOff(ie.x,ie.y,ie.x+25,ie.y+25,2,7,2);
      IconOff(il.x,il.y,il.x+25,il.y+25,2,7,3);
      IconOff(ii.x,ii.y,ii.x+25,ii.y+25,2,7,4);
      IconOff(is.x,is.y,is.x+25,is.y+25,2,7,5);
      IconOff(it.x,it.y,it.x+25,it.y+25,2,7,6);
      IconOff(ia.x,ia.y,ia.x+25,ia.y+25,2,7,7);
    end;
End;

End.