Unit Lista;

Interface
{Nota:Array[1..15] of String[70];}
Type
  ListaPtr=^Nodo;
  Nodo    =Record
    No,                  {Contador de Lista}
    xi,yi,               {Puntos iniciales del campo}
    xf,yf,               {Puntos finales   del campo}
    tx,ty       :Integer;{Tamao del Campo}
    Nombre,
    Long1,Long2 :String; {Datos generales del campo }
    Tipo        :Char;   {Tipo del campo}
    Forma       :Boolean;{Forma en que se acomodan los campos}
                         {True:Por debajo;False:Campo corrido}
    Ptr:ListaPtr;
  end;

Var
  L1,L2    :ListaPtr;
  Dato     :Nodo;
  ListCont :Integer;

{Prosecos para los Menus}
Function  CheckDataListType:Integer;
Procedure NewDataListType;
{Prosecos de las Listas }
Procedure Iniciar_Lista(tipo:byte);
Procedure InsertList(Var Final:ListaPtr;InDato:Nodo);
Function  CheckPointList(xi,yi,xf,yf:Integer;Inicio:ListaPtr):Integer;
Function  ChkPtrMouList(x,y:Integer;Inicio:ListaPtr):Integer;
Procedure Borrar(Var BorL:ListaPtr;Temp:ListaPtr;bDato:Integer);
Procedure Leer(Inicio:ListaPtr);
Procedure GuardarComo;
Procedure GuardarComopato;


Implementation
Uses
  Dos,Graph,Interfac,UtMouV04,Frases,
  Arrastre,Cab,Variable,Iconos,SubMenus;

Function CheckDataListType:Integer;
{Comprueba si los datos de la lista estan
 complestos para continuar el proseso    }
Begin
  if (Dato.Nombre<>'')and(Dato.Long1<>'')and(Dato.Long2<>'') then
    CheckDataListType:=1
  else
    CheckDataListType:=0;
End;

Procedure NewDataListType;
{Inicializa los datos de la lista ligada}
Begin
  Dato.Nombre:='';
  Dato.Long1:='';
  Dato.Long2:='';
End;

Procedure Iniciar_Lista(tipo:byte);
Begin
  New(L1);
  ListCont:=0;
  L1^.No:=-500;
  L1^.xi:=-500;
  L1^.yi:=-500;
  L1^.xf:=-500;
  L1^.yf:=-500;
  L1^.Nombre:=NuevoAbrirEditor(Tipo);
  L1^.Long1  :='CABEZERA';
  L1^.Long2  :='MULTIMED';
  L1^.Tipo  :='&';
  L1^.Forma :=True;
  L1^.Ptr:=nil;
  L2     :=L1;
End;

Procedure InsertList(Var Final:ListaPtr;InDato:Nodo);
{Inserta un campo a la lista ligada}
Var
  Nuevo:ListaPtr;
Begin
  New(Nuevo);
  Nuevo^.No:=ListCont;
  Nuevo^.xi:=InDato.xi;
  Nuevo^.yi:=InDato.yi;
  Nuevo^.xf:=InDato.xf;
  Nuevo^.yf:=InDato.yf;
  Nuevo^.tx:=InDato.tx;
  Nuevo^.ty:=InDato.ty;
  Nuevo^.Nombre:=InDato.Nombre;
  Nuevo^.Long1 :=InDato.Long1;
  Nuevo^.Long2 :=InDato.Long2;
  Nuevo^.Tipo  :=InDato.Tipo;
  Nuevo^.Forma :=InDato.Forma;
  Nuevo^.Ptr:=nil;
  if final^.ptr <> nil then
  repeat
    final:=final^.ptr
  until final^.ptr = nil;
  Final^.Ptr:=Nuevo;
  Final:=Nuevo;
{  Final^.Ptr:=Nuevo;
  Final:=Nuevo;}
End;

Function CheckPointList(xi,yi,xf,yf:Integer;Inicio:ListaPtr):Integer;
{Checa si no se empalman los campos}
Var
  Flag  :Boolean;
  cxy   :Integer;
  cx,cy :Integer;

Begin
  Flag:=False;
  CheckPointList:=1;
  While Inicio<>nil do
    Begin
      if Flag=False then
        For cxy:=0 to Dato.tx do
          if (xi+cxy >= Inicio^.xi) and (xi+cxy <= Inicio^.xf) and
             (yi     >= Inicio^.yi) and (yi     <= Inicio^.yf) then
             Begin
               CheckPointList:=0;
               cxy:=Dato.tx;
               Flag:=True;
               Inicio:=nil;
             end;
      if Flag=False then
        For cxy:=0 to Dato.tx do
          if (xi+cxy >= Inicio^.xi) and (xi+cxy <= Inicio^.xf) and
             (yf     >= Inicio^.yi) and (yf     <= Inicio^.yf) then
             Begin
               CheckPointList:=0;
               cxy:=Dato.tx;
               Flag:=True;
               Inicio:=nil;
             end;
      if Flag=False then
        For cxy:=0 to Dato.ty do
          if (xi     >= Inicio^.xi) and (xi     <= Inicio^.xf) and
             (yi+cxy >= Inicio^.yi) and (yi+cxy <= Inicio^.yf) then
             Begin
               CheckPointList:=0;
               cxy:=Dato.tx;
               Flag:=True;
               Inicio:=nil;
             end;
      if Flag=False then
        For cxy:=0 to Dato.ty do
          if (xf     >= Inicio^.xi) and (xf     <= Inicio^.xf) and
             (yi+cxy >= Inicio^.yi) and (yi+cxy <= Inicio^.yf) then
             Begin
               CheckPointList:=0;
               cxy:=Dato.tx;
               Flag:=True;
               Inicio:=nil;
             end;
      if Flag=False then
         For cy:=0 to Dato.ty do
           Begin
             For cx:=0 to Dato.tx do
               if (xi+cx >= Inicio^.xi) and (xi+cx <= Inicio^.xf) and
                  (yi+cy >= Inicio^.yi) and (yi+cy <= Inicio^.yf) then
                  Begin
                    CheckPointList:=0;
                    cx:=Dato.tx;
                    cy:=Dato.ty;
                    Inicio:=nil;
                  end;
             if cy < Dato.ty then
                cy:=cy+14;
             if cy > Dato.ty then
                cy:=Dato.ty;
           end;
      if Inicio<>nil then
         Inicio:=Inicio^.Ptr;
    end;
End;

Function ChkPtrMouList(x,y:Integer;Inicio:ListaPtr):Integer;
Begin
  ChkPtrMouList:=0;
  While Inicio<>nil do
    Begin
      if (x >= Inicio^.xi) and (x <= Inicio^.xf) and
         (y >= Inicio^.yi) and (y <= Inicio^.yf) then
         Begin
           ChkPtrMouList:=1;
           Dato.No:=Inicio^.No;
           Dato.xi:=Inicio^.xi;
           Dato.yi:=Inicio^.yi;
           Dato.xf:=Inicio^.xf;
           Dato.yf:=Inicio^.yf;
           Dato.tx:=Inicio^.tx;
           Dato.ty:=Inicio^.ty;
           Dato.Nombre:=Inicio^.Nombre;
           Dato.Long1:=Inicio^.Long1;
           Dato.Long2:=Inicio^.Long2;
           Dato.Tipo:=Inicio^.Tipo;
           Dato.Forma:=Inicio^.Forma;
           Inicio:=nil;
         end;
      if Inicio<>nil then
         Inicio:=Inicio^.Ptr;
    end;
End;

Procedure Borrar(Var BorL:ListaPtr;Temp:ListaPtr;bDato:Integer);
Var
  Lista  :ListaPtr;
  Poin   :Pointer;
  Flag   :Boolean;

Begin
  Flag:=False;
  Ayuda('',0);
  Ayuda('CONFIRMAR ELIMINAR:',4);
  RatonOff;
  BotonOff('Si',575,6,5,3,1);
  BotonOff('No',610,6,5,3,1);
  RatonOn;
  Repeat
    Reg.ax:=$03;
    Intr($33,Reg);
    if Reg.bx=$01 then
      Begin
        if BotonExe('Si',575,6,5,3,1,0)=1 then
          {Borra el campo de la lista}
          Begin
            Poin:=Temp;
            Temp:=Temp^.Ptr;
            While (Temp^.No<>bDato) and (Temp<>nil) do
              Begin
                Poin:=Temp;
                Temp:=Temp^.Ptr;
              end;
            Lista:=BorL;
            While Lista<>Poin do
              Lista:=Lista^.Ptr;
            if Temp^.Ptr=nil then
              Begin
                L2:=Poin;
                L2^.Ptr:=nil;
              end
            else
              if Temp<>nil then
                Lista^.Ptr:=Temp^.Ptr;
            RatonOff;
            {Pega la imagen inferior de los Icono}
            PutImage(v.ba.x,v.ba.y,p.ip^,NormalPut);
            {Borra el Campo}
            SetFillStyle(1,7);
            Bar(Dato.xi,Dato.yi,Dato.xf,dato.yf);
            {}IconosPaint;
            RatonOn;
            Flag:=True;
          end;
        if BotonExe('No',610,6,5,3,1,0)=1 then
          Flag:=True;
      end;
  Until Flag=True;
  Ayuda('',0);
End;

Procedure Leer(Inicio:ListaPtr);
Begin
  While Inicio<>nil do
    Begin
           Dato.No:=Inicio^.No;
           Dato.xi:=Inicio^.xi;
           Dato.yi:=Inicio^.yi;
           Dato.xf:=Inicio^.xf;
           Dato.yf:=Inicio^.yf;
           Dato.tx:=Inicio^.tx;
           Dato.ty:=Inicio^.ty;
           Dato.Nombre:=Inicio^.Nombre;
           Dato.Long1:=Inicio^.Long1;
           Dato.Long2:=Inicio^.Long2;
           Dato.Tipo:=Inicio^.Tipo;
           Dato.Forma:=Inicio^.Forma;
           PintaCampo;
           Inicio:=Inicio^.Ptr;
    end;
End;

Procedure GuardarComo;
Const
  x=100;
  y=100;
Begin
  RatonOff;
  {GeneralMenu('Nuevo Archivo',x,y,100,100,1);
  }OutTextXY(x+2,y,'Nombre del Archivo:');
  Fondo(x+160,y-3,x+230,y+10,0,1,8,15,7);
  L1^.Nombre:=NomCad(x+163,y,8,0);
  SetFillStyle(1,7);
  Bar(x,y-5,x+240,y+30);
  GuardaCab(L1);
  RatonOn;
End;

Procedure GuardarComoPato;
Const
  x=100;
  y=100;
Begin
  RatonOff;
  {GeneralMenu('Nuevo Archivo',x,y,100,100,1);
  }OutTextXY(x+2,y,'Nombre del Archivo:');
  Fondo(x+160,y-3,x+230,y+10,0,1,8,15,7);
  SetFillStyle(1,7);
  Bar(x,y-5,x+240,y+30);
  ;
  RatonOn;
End;

End.

